<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>StringType - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="EnumType.html">EnumType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="EnumType.html#getInterpolatedValue">getInterpolatedValue</a></li></ul></li><li><a href="ListType.html">ListType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ListType.html#cost">cost</a></li></ul></li><li><a href="MidiType.html">MidiType</a><ul class='members'></ul></li><li><a href="ModalType.html">ModalType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ModalType.html#getPi">getPi</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getNu">getNu</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getTau">getTau</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getRho">getRho</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getOp">getOp</a></li></ul></li><li><a href="NumericType.html">NumericType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NumericType.html#getNormalized">getNormalized</a></li></ul></li><li><a href="RecordType.html">RecordType</a><ul class='members'></ul></li><li><a href="SetType.html">SetType</a><ul class='members'></ul></li><li><a href="StringType.html">StringType</a><ul class='members'></ul></li><li><a href="SvgType.html">SvgType</a><ul class='members'></ul></li><li><a href="Type.html">Type</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getCheckMessage">getCheckMessage</a></li><li data-type='method' style='display: none;'><a href="Type.html#getDistance">getDistance</a></li><li data-type='method' style='display: none;'><a href="Type.html#getPath">getPath</a></li><li data-type='method' style='display: none;'><a href="Type.html#compare">compare</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBound">getBound</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBounds">getBounds</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getType">getType</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeNames">getTypeNames</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeParameters">getTypeParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#.addType">addType</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#json2midi">json2midi</a></li><li><a href="global.html#json2svg">json2svg</a></li><li><a href="global.html#midi2Jon">midi2Jon</a></li><li><a href="global.html#svg2json">svg2json</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">StringType</h1>
    

    




<section>

<header>
    
        <h2>
        
            StringType
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="StringType"><span class="type-signature"></span>new StringType<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Specifies a string type.</p>
<h4>Extends: <a href='./Type.html'>Type</a>, with all public methods available.</h4>
<p><a name="parameters"></a></p>
<h2>Type parameters</h2>
<h3>General parameter</h3>
<ul>
<li><code>name: ...</code> The type name, if specific. By default the type name is <code>string</code>.</li>
</ul>
<h3>Parameters for the syntactic projection</h3>
<ul>
<li><code>checkPattern</code>: The <a href="https://line.gitlabpages.inria.fr/aide-group/aidesys/regex.html">regex</a> pattern defining if the string is valid. By default any string is valid.
<ul>
<li>Using <code>(value_1|value_2|...)</code> allows to define an enumeration, i.e., constraints the string to equal only one of these values.
<ul>
<li>This corresponds to a <a href="./EnumType.html">EnumType</a>.</li>
</ul>
</li>
<li>Using a unique value allows to define a constant value, i.e., constraint the string to equal only this value.</li>
</ul>
</li>
<li><code>minLength: ...</code> The minimal length of the string. By default <code>0</code>.</li>
<li><code>maxLength: ...</code> The maximal length of the string. By default unbounded (<code>-1</code>).</li>
</ul>
<h3>Parameters for the cost calculation</h3>
<ul>
<li><code>deleteCost: ...</code> The non-negative deleting cost value. Default is <code>1</code>.</li>
<li><code>insertCost: ...</code> The non-negative inserting cost value. By default equals to the <code>deleteCost</code>.</li>
<li><code>editCost: ...</code> The non-negative editing cost value. Default is 1.</li>
</ul>
<h3>Parameters for the geodesic calculation</h3>
<ul>
<li><code>atomic: ...</code>
<ul>
<li>If true returns only an atomic path with the two left-hand and right-hand elements. Default is true.</li>
<li>If false returns a path with all intermediate edition.</li>
</ul>
</li>
</ul>
<h3>Parameters for the bounds calculation</h3>
<ul>
<li><code>bounds</code>: ...` A list of bounds for the string, manually defined.
<a name="specification"></a></li>
</ul>
<h2>StringType specification</h2>
<table class="specification">
<tr style='border: 1px solid black;'><th> Syntactic projection </th><td>
- If the value is not a string but a structured value, a message is issued and the string representation of the structured value is taken.
<br/> - If the string syntax is incorrect with respect to the optional <tt>checkPattern</tt> regex, a message is issued, but the string is unchanged.
<br/> - If the string length is not in the (optional) <tt>[minLength, maxLength]</tt> bounds, a message is issued, but the string is unchanged.
</td></tr>
<tr style='border: 1px solid black;'><th> Semantic projection  </th><td>
- Any value as <a href="https://line.gitlabpages.inria.fr/aide-group/wjson/Value.html#asString">wJSON value</a> has a string representation.
</td></tr>
<tr style='border: 1px solid black;'><th> Distance value       </th><td>
- The distance is computed as a usual <a href="https://en.wikipedia.org/wiki/Edit_distance">edit distance</a>.
<br/> &nbsp;&nbsp;&nbsp;&nbsp; - It is delegated to the <a href="./ListType.html">ListType</a> applied on the char list of the string.
</td></tr>
<tr style='border: 1px solid black;'><th> Geodesic path        </th><td>
- If <tt>atomic</tt> the geodesic is of length 1 if the string are equal, and 2 otherwise.
- If not atomic, the geodesic is computed from the edit distance.
</td></tr>
<tr style='border: 1px solid black;'><th> Comparison           </th><td>
- Returns <tt>0</tt> If each char pair compares equal and both strings have the same length.
<br/> - Returns <tt><0</tt> If either the value of the first char that does not match is lower in the left hand side string, or all compared chars match but the left hand side string is shorter.
<br/> - Returns <tt>>0</tt> If either the value of the first char that does not match is greater in the left hand side string, or all compared chars match but the left hand side string is longer.
</td></tr>
<tr style='border: 1px solid black;'><th> Bounds           </th><td>
- The <tt>bounds</tt> are manually entered as parameters, otherwise the empty value is the unique bound.
</td></tr>
</table></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The type parameters.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Members</h3>

        
            













        
    

    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>